#include "ekglog.hpp"
#include <utility>

using namespace EkgLog;

void UinLog::fillChats (const time_t interval)
{
  if (!_chats.empty())
  // usu obecny podzia na czaty
    _chats.clear();
  // a jeli nie ma adnych wiadomoci?
  if (_msg.begin() == _msg.end())
    return; // po prostu wyjd
  std::list<Message>::iterator beg, end, i;
  Chat chat;
  unsigned int lp = 2;

  beg = end = i = _msg.begin();
  beg->set_no (1);
  ++i;
  while (i != _msg.end()) {
    if (i->recv() - end->recv() >= interval) {
      ++end;
      chat.begin (beg);
      chat.end (end);
      _chats.insert (std::make_pair (chat.time(),chat));
      beg = end;
      beg->set_no (1);
      lp = 2;
      ++i;
    } else {
      i->set_no (lp++);
      ++end;
      ++i;
    }
  }
  // jeszcze jeden chat zostanie...
  ++end;
  chat.begin (beg);
  chat.end (end);
  _chats.insert (std::make_pair (chat.time(),chat));
} // fillChats
  
