/*
 *      Program do przegladania logow z ekg.
 *      Obsluga wiekszosci bledow.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "errors.h"


std::vector<std::string> errors;

void error_exit(char *fmt, ...) {
    char buf[2048];

    va_list ap;
    va_start(ap,fmt);

    vsnprintf(buf,2048,fmt,ap);
    va_end(ap);

    std::cerr << "\n\n   *** Bd ekglog ***\n\n  " << buf << '\n';

    exit(1);
}

void error_notice(char *fmt, ...) {
    char buf[2048];

    va_list ap;
    va_start(ap,fmt);
    vsnprintf(buf,2048,fmt,ap);
    va_end(ap);

//    if(cfg.log()) {
//        cfg.log_file() << "\n\n   *** Bd ekglog ***\n\n  " << buf << '\n';
//    }
    
    errors.push_back(buf);
}
